(**************************************************************************)
(*  The CDuce interpreter                                                 *)
(*  Alain.Frisch@ens.fr                                                   *)
(*  Copyright 2003 (see LICENSE for details)                              *)
(**************************************************************************)

ifdef ML_INTERFACE then
type ocaml_t = 
    { ml_id: string;
      ml_name: string;
      ml_kind: ocaml_kind;
      mutable ml_rec: bool;
      mutable ml_decl: ocaml_decl }
    
and ocaml_kind =
  | ML_type
  | ML_value
  | ML_module of ocaml_t list
	
and ocaml_decl =
  | ML_nil
  | ML_abstract of ocaml_desc
  | ML_record of ( string * ocaml_desc ) list
  | ML_variant of ( string * ocaml_desc list ) list
	
and ocaml_desc =
  | ML_arrow of string option * ocaml_desc * ocaml_desc
  | ML_bool
  | ML_char
  | ML_ident of string * ocaml_desc array * ocaml_t
  | ML_int
  | ML_list of ocaml_desc
  | ML_option of ocaml_desc
  | ML_reference of ocaml_desc
  | ML_string
  | ML_tuple of ocaml_desc list
  | ML_unit
  | ML_var of int

ifdef ML_INTERFACE then
type cduce_t = Types.t;;
