open Ident 
open Lambda

type env
val from_comp_unit: (Types.CompUnit.t -> env) ref

val dump: Format.formatter -> env -> unit

val empty : env
val serialize: env Serialize.Put.f
val deserialize: env Serialize.Get.f

val enter_global : env -> id -> env
val enter_globals : env -> id list -> env
val find : id -> env -> var_loc

val compile_eval : env -> Typed.texpr -> code_item
val compile_let_decl : env -> Typed.let_decl -> env * code_item
val compile_rec_funs : env -> Typed.texpr list -> env * code_item


val comp_unit:
  ?run:bool ->
  ?show:(id option -> Types.t -> Value.t option -> unit) ->
  ?loading:(Types.CompUnit.t -> unit) ->
  ?directive:(Typer.t -> env -> Ast.toplevel_directive -> unit) ->

  Typer.t -> env -> 
  Ast.pmodule_item list -> Typer.t * env * Lambda.code_item list
